/*
 * LM235Z.c
 *
 *  Created on: Jun 23, 2023
 *      Author: reinicke
 */

#include "LM235Z.h"
#include "LM235Z_cfg.h"
#include "DWT_Delay.h"

static ADC_HandleTypeDef hadc = {0};
static ADC_ChannelConfTypeDef sConfig = {0};
static uint8_t calibrated = 0;

void LM235Z_Init(uint16_t LM235Z_Instance)
{
	if(LM235Z_CfgParam[LM235Z_Instance].LM235Z_GPIO == GPIOA)
	{
		__HAL_RCC_GPIOA_CLK_ENABLE();
	}
	else if(LM235Z_CfgParam[LM235Z_Instance].LM235Z_GPIO == GPIOB)
	{
		__HAL_RCC_GPIOB_CLK_ENABLE();
	}
	else if(LM235Z_CfgParam[LM235Z_Instance].LM235Z_GPIO == GPIOC)
	{
		__HAL_RCC_GPIOC_CLK_ENABLE();
	}
	else if (LM235Z_CfgParam[LM235Z_Instance].LM235Z_GPIO == GPIOD)
	{
		__HAL_RCC_GPIOD_CLK_ENABLE();
	}
	hadc.Instance = LM235Z_CfgParam[LM235Z_Instance].ADC_Instance;
	hadc.Init.ScanConvMode = DISABLE;
	hadc.Init.ContinuousConvMode = DISABLE;
	hadc.Init.DiscontinuousConvMode = DISABLE;
	hadc.Init.ExternalTrigConv = ADC_SOFTWARE_START;
	hadc.Init.DataAlign = ADC_DATAALIGN_RIGHT;
	hadc.Init.NbrOfConversion = 1;
	HAL_ADC_Init(&hadc);
    sConfig.Channel = LM235Z_CfgParam[LM235Z_Instance].ADC_CH;
	sConfig.Rank = ADC_REGULAR_RANK_1;
	sConfig.SamplingTime = ADC_SAMPLETIME_28CYCLES_5;
	HAL_ADC_ConfigChannel(&hadc, &sConfig);

	if(calibrated == 0)
	{
		HAL_ADCEx_Calibration_Start(&hadc);
		calibrated = 1;
	}
	DWT_Delay_Init();
}
